package crafttweaker.mc1120.world;

import java.util.LinkedList;
import java.util.List;

import crafttweaker.CraftTweakerAPI;
import crafttweaker.api.entity.IEntity;
import crafttweaker.api.entity.IEntityDefinition;
import crafttweaker.api.world.IBiome;
import crafttweaker.mc1120.entity.MCEntityDefinition;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.biome.Biome.SpawnListEntry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.registry.ForgeRegistries;

/**
 * @author Stan
 */

public class MCBiome implements IBiome {

    private final Biome biome;

    public MCBiome(Biome biome) {
        this.biome = biome;
    }

    @Override
    public String getName() {
        return biome.func_185359_l();
    }

	@Override
	public boolean getCanRain() {
		return biome.func_76738_d();
	}

	@Override
	public boolean isSnowyBiome() {
		return biome.func_150559_j();
	}

	@Override
	public boolean getIsHighHumidity() {
		return biome.func_76736_e();
	}

	@Override
	public float getSpawningChance() {
		return biome.func_76741_f();
	}

	@Override
	public float getBaseHeight() {
		return biome.func_185355_j();
	}

	@Override
	public float getRainfall() {
		return biome.func_76727_i();
	}

	@Override
	public int getWaterColorMultiplier() {
		return biome.getWaterColorMultiplier();
	}

	@Override
	public boolean getIgnorePlayerSpawnSuitability() {
		return biome.func_185352_i();
	}

	
	
	@Override
	public float getHeightVariation() {
		return biome.func_185360_m();
	}

	@Override
	public float getTemperature() {
		return biome.func_185353_n();
	}
}
